// tool.cpp
// @[`̋ʃC^[tFCXNXB

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/

#include "stdafx.h"
#include "resource.h"
#include "Tool.h"

unsigned char* CTool::common_buf;

char* CTool::GetPassword()
{
	delete [] m_pPass;
	DialogBoxParam( GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_PASS),
					NULL,PassProc, (LPARAM)(&m_pPass) );
	return m_pPass;
}

BOOL CALLBACK CTool::PassProc( HWND dlg,UINT msg,WPARAM wp,LPARAM lp )
{
	if( msg==WM_INITDIALOG )
	{
		SetWindowLong( dlg, GWL_USERDATA, lp );
		SendDlgItemMessage( dlg, IDC_MASK, BM_SETCHECK, BST_CHECKED, 0 );
		SetFocus( GetDlgItem(dlg,IDC_PASSWORD) );
		kiutil::wndFront( dlg );
		return TRUE;
	}
	else if( msg==WM_COMMAND )
	{
		if( LOWORD(wp)==IDOK )
		{
			int len = SendDlgItemMessage( dlg,IDC_PASSWORD,
										WM_GETTEXTLENGTH,0,0);

			char** ppPass=(char**)GetWindowLong(dlg,GWL_USERDATA);
			*ppPass=new char[1+len];

			SendDlgItemMessage(dlg,IDC_PASSWORD,WM_GETTEXT,
									len+1,(LPARAM)*ppPass);
			EndDialog(dlg,IDOK);
			return TRUE;
		}
		else if( LOWORD(wp)==IDC_MASK )
		{
			if( BST_CHECKED==
					SendDlgItemMessage( dlg,IDC_MASK,
										BM_GETCHECK,0,0 ) )
				SendDlgItemMessage( dlg,IDC_PASSWORD,
									EM_SETPASSWORDCHAR,'*',0 );
			else
				SendDlgItemMessage( dlg,IDC_PASSWORD,
									EM_SETPASSWORDCHAR,0,0 );
			InvalidateRect( GetDlgItem(dlg,IDC_PASSWORD),
												NULL,TRUE );
			return TRUE;
		}
	}
	return FALSE;
}
