#ifndef AFX_BGATOOL_H__5C536C62_46D0_11D4_8D96_AE068B524B38__INCLUDED_
#define AFX_BGATOOL_H__5C536C62_46D0_11D4_8D96_AE068B524B38__INCLUDED_

#include "Tool.h"

struct BgaHeader
{
	DWORD checksum;			// signed  type-fname ̘a
	char  type[4];			// "GZIP" ܂ "BZ2"
	DWORD compressed_size;	// k̃f[^TCY( wb_͊܂܂Ȃ )
	DWORD original_size;	// ̃t@CTCY
	WORD  date;				// t@C̍XVt( DOS` )
	WORD  time;				// t@C̍XV( DOS` )
	BYTE  attrib;			// t@C̑
							// ( 1:RO 2:Hid 4:Sys 8:Vol 16:Dir 32:Arc )
	BYTE  header_type;		// wb_̎( ݂͏ 0 )
	WORD  arc_type;			// A[JCu^Cv
							// 0:(ext== ? 񈳏k : k) 1:k 2:񈳏k
							//	.ARC, .ARJ, .BZ2, .BZA, .CAB, .GZ, .GZA, .LZH,
							//	.LZS, .PAK, .RAR, .TAZ, .TBZ, .TGZ, .Z, .ZIP, .ZOO
	WORD  dir_name_len;		//
	WORD  file_name_len;	//
	char  name[MAX_PATH];	// dir_name_len + file_name_len ( no '\0' )
};

class CBgaTool : public CTool
{
//
// using
//
// zlib 1.2.2
//   http://www.gzip.org/zlib/
// Copyright (C) 1995-2004 Jean-loup Gailly and Mark Adler
//
// libbzip2 1.0.3
//   http://www.bzip.org
// Copyright (C) 1996-2005 Julian R Seward.  All rights reserved.
//
// see "zlib/README" and "libbzip2/LICENSE"
//
//
// wb_\̏񂠂肪Ƃ܂I  ؑ
//

public:
	CBgaTool() : CTool( "Bza/Gza WJ" ){}

	bool IsType( const char* ext )
		{return 0==stricmp(ext,"gza") || 0==stricmp(ext,"bza");}
	bool Check( const char* fname, unsigned long fsize );
	bool Extract( const char* fname, const char* ddir );

private:
	bool GzDec( FILE* in, FILE* out, unsigned long origsize );
	bool BzDec( FILE* in, FILE* out, unsigned long origsize );
	bool NcDec( FILE* in, FILE* out, unsigned long origsize );

	bool IsCompressed( BgaHeader* hdr );

	bool ReadHeader( FILE* in, BgaHeader* hdr );
	int  FindHeader( const unsigned char* dat, unsigned long siz );
};

#endif
